/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef _NEST_ADVERTISER_H
#define _NEST_ADVERTISER_H

#include "nest_common.h"
#include "nest_protocol.h"
#include "nest_protocol_manager.h"

#define AD_NAME "NestAd"

class
nestAd {

public:
    nestAd( nestProtocol *src, int len );

    ~nestAd( );

    char *toString( );

    int length( );

private:
    char *myad;
    int  mylen;
};

class
nestAdvertiser {

public:

    static int init( );

    static NestReplyStatus writeAd( nestProtocol *dest );

    static nestAd *readAd( nestProtocol *src, int len );
    
private:

};

#endif
