/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef _NEST_CONCURRENCY_POT_H
#define _NEST_CONCURRENCY_POT_H

#include "nest_concurrency_model.h"
#include "nest_client_pool.h"

struct ThreadArgs;

class nestConcurrencyPot : public nestConcurrencyModel {
public:
    
    nestConcurrencyPot( int pool_size, fd_set *readfds, taskDoneCallback cb,
            int id );
    
    virtual ~nestConcurrencyPot( );
    
    virtual NestReplyStatus addTask( nestClient *client );
    
    virtual NestReplyStatus makeProgress( fd_set *r_ready, fd_set *w_ready );

    virtual int getMaxfd( );

    virtual char* toString();

    bool directCallback();
    
private:

    NestReplyStatus clearNestSignal( );
    
    struct ThreadArgs   *thread_args;

    fd_set *readfds;
};

#endif
