/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef _NEST_GLOBUS_H
#define _NEST_GLOBUS_H

extern "C" {
#include "globus_common.h"
}
extern "C" {
    #include "globus_ftp_control.h"
}
extern "C" {
    #include "globus_ftp_client.h"
}
extern "C" {
    #include "globus_fifo.h"
}
extern "C" {
    #include "globus_gss_assist.h"
}

#include "nest_common.h"

#define AUTH_SUBJECT_MAX 1024                                                   
#define AUTH_TYPE_MAX 1024                                                      
#define AUTH_LINE_MAX 80

NestReplyStatus inquireGlobusCredential(    gss_name_t *name, 
                                            OM_uint32 *lifetime,
                                            gss_cred_id_t *credential_handle) ;

NestReplyStatus acquireGlobusCredential( gss_cred_id_t *cred_handle,
        gss_cred_usage_t credential_usage );

NestReplyStatus auth_globus_accept( int socket, char **subject, char **globus_username );

int auth_globus_assert( int socket, char *server );

#endif
