#include "nest_pread.h"

/* A number of platforms fail to prototype these functions */
//extern ssize_t pread( int fd, void *buf, size_t count, off_t offset );
//extern ssize_t pwrite( int fd, const void *buf, size_t count, off_t offset );

ssize_t 
NestPwrite( int fd, const void *buf, size_t count, off_t offset ) {
    ssize_t w = pwrite( fd, buf, count, offset );
    if ( w < 0 ) nest_perror( "pwrite" );
    return w;

}

ssize_t 
NestPread( int fd, void *buf, size_t count, off_t offset ) {
    ssize_t r = pread( fd, buf, count, offset );
    if ( r < 0 ) nest_warn( __FILE__, __FUNCTION__, "pread fd:%d, off:%ld, size:%ld %s", fd, offset, count, strerror(errno) );
    return r;
}

