/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#include "nest_common.h"
#include "nest_protocol_storage.h"

bool
nestProtocolStorage::sendErrorMessage( const char* filename, const char* func_name,  int error ) {
    PROTOCOL_DIE;
    return false;
}

bool
nestProtocolStorage::sendAck( ) {
    PROTOCOL_DIE;
    return false;
}

nestRequest *
nestProtocolStorage::receiveRequest( fd_set *ready ) {
    PROTOCOL_DIE;
    return NULL;
}

bool
nestProtocolStorage::get_fd_cache_status( ) {
    PROTOCOL_DIE;
    return false;
}


void
nestProtocolStorage::set_fd_cache_status( bool ) {
    PROTOCOL_DIE;
    return;
}

bool
nestProtocolStorage::sendFilesize( long size ) {
    PROTOCOL_DIE;
    return false;
}

int
nestProtocolStorage::set_filenames(char *logical_name, char *physical_name) {
    PROTOCOL_DIE;
    return false;
}

int
nestProtocolStorage::set_fdkey( char *fdkey ) {
    PROTOCOL_DIE;
    return -1;
}

char *
nestProtocolStorage::get_fdkey( ) {
    PROTOCOL_DIE;
    return NULL;
}

int
nestProtocolStorage::get_filenames(char *logical_name, char *physical_name)  {
    PROTOCOL_DIE;
    return false;
}


int
nestProtocolStorage::set_open_flags(int flags) {
    PROTOCOL_DIE;
    return false;
}


int
nestProtocolStorage::get_open_flags(int *flags) {
    PROTOCOL_DIE;
    return false;
}

int
nestProtocolStorage::set_open_filesize(off_t size) {
    PROTOCOL_DIE;
    return false;
}


int
nestProtocolStorage::get_open_filesize(off_t *size) {
    PROTOCOL_DIE;
    return false;
}

int
nestProtocolStorage::set_ids(user_id_t uid, user_id_t gid) {
    PROTOCOL_DIE;
    return false;
}

int
nestProtocolStorage::get_ids(user_id_t *uid, user_id_t *gid) {
    PROTOCOL_DIE;
    return false;
}
