#ifndef __NEST_PROXY_H_
#define __NEST_PROXY_H_

#include "nest_common.h"
#include "nest_client_pool.h"
#include "dynamic-lard.h"
#include "nest_protocol_proxy.h"
#include "nest_proxy_fetch.h"

#include "nest_proxy_client_cache.h"

bool serverIsProxy();

int initProxy(	int( *transferFP )(nestClient*,bool),
							nestClientPool *clientPool,
							fd_set *read_fds );

NestReplyStatus proxyRegisterProxyClient( nestClient *client, char *proxy );

NestReplyStatus addNewClientToProxy( nestClient *client );

NestReplyStatus removeClientFromProxy( nestClient *client );

NestReplyStatus connectMonitor( char *monitor );

NestReplyStatus FlushProxyCache( nestClient *client );

NestReplyStatus ReceiveProxyIndex( nestClient *client );

int	getProxyCount();

NestReplyStatus openHomeConnection( nestClient ** );

NestReplyStatus proxyTranslateRequest( nestClient *client );

NestReplyStatus addProxyTransfer( nestClient *client );

bool taskWasProxyTask( nestClient *client, NestReplyStatus status );

NestReplyStatus flushDirtyWrites( nestClient *client );

void writeProxyAd( nestProtocol *ad );

void proxyHelp();

void proxyMaintenance();

NestReplyStatus startProxyFetch( nestProxyFetch *fetch );

NestReplyStatus  proxyFilelength(  long *filesize,  
                                   const char *filename,
                                   const char *user,
                                   const char *cwd );

#endif
