/***********************************************************************
 *
 * NeST: Network Storage Technologies
 * Copyright (C) 2001-2002, Computer Sciences Department,
 * University of Wisconsin-Madison, WI, and John Bent, 
 * Venkateshwaran Venkataramani, and other members of the Condor Project
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License version
 * 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 * 
 * For contact information, please visit: 
 *      http://www.cs.wisc.edu/condor/nest/
 *
 ***********************************************************************/

#ifndef PTHREAD_UTIL
#define PTHREAD_UTIL

#ifdef USE_PTHREADS

#include<pthread.h>
#include"nest_common.h"

int nest_pthread_mutex_init(pthread_mutex_t *,const pthread_mutexattr_t *);
int nest_pthread_cond_init(pthread_cond_t *cond,const pthread_condattr_t *attr);
int nest_pthread_cond_destroy(pthread_cond_t *cond);
int nest_pthread_mutex_lock(pthread_mutex_t *mp);
int nest_pthread_mutex_unlock(pthread_mutex_t *mp);
int nest_pthread_mutex_destroy(pthread_mutex_t *mp);
int nest_pthread_cond_wait( pthread_cond_t *cvp, pthread_mutex_t *mp );
int nest_pthread_cond_timedwait(pthread_cond_t *cvp, pthread_mutex_t *mp,
               struct timespec *abstime);
int nest_pthread_cond_signal(pthread_cond_t *cond);
int nest_pthread_cond_broadcast(pthread_cond_t *cond);
int nest_pthread_create(pthread_t *new_thread_ID, const pthread_attr_t *attr,
           void * (*start_func)(void *), void *arg);
int nest_pthread_attr_init(pthread_attr_t *attr);
int nest_pthread_attr_setscope(pthread_attr_t *attr, int contentionscope);
int nest_pthread_attr_setschedpolicy(pthread_attr_t *attr, int policy);

#endif

#endif
