/*nfs
 * This is sample code generated by rpcgen.
 * These are only templates and you can use them
 * as a guideline for developing your own functions.
 * this was originally generated as nfs_prot_server.c from rpcgen -a nfs_prot.x
 */

#include "nfs_prot.h"
#include "nfs_mount.h"
#include "nfs_util.h"

#include "nest_common.h"
#include "nest_debug.h"
#include "nest_request.h"
#include "nest_storage_manager.h"   // for looking up fh's for debugging

#define NFS_WARN nest_debug( NEST_DEBUG_NFS, \
        "nest_nfs unimplemented method called %s: %d\n", __FILE__, __LINE__ );

nestRequest *
nfsproc_null_2_svc(void *argp, struct svc_req *rqstp)
{
    // this is a no-op used for testing speeds
    // we could just handle this one locally
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
nfsproc_getattr_2_svc(nfs_fh *argp, struct svc_req *rqstp)
{
    NestFilehandle nest_fh;
    memcpy( &nest_fh, argp, sizeof( NestFilehandle ) );
    nest_debug( NEST_DEBUG_NFS, "nfs getattr req for %s received\n", 
        nestStorageManager::filehandleToPath( &nest_fh ) ); 

    nestRequest *req = new nestRequest( FILEINFO_REQUEST, NULL, 0, 0, 0, 0, 0 );
    req->setFilehandle( argp );

    return req; 
}

nestRequest *
nfsproc_setattr_2_svc(sattrargs *argp, struct svc_req *rqstp)
{
    NestFilehandle nest_fh;
    memcpy( &nest_fh, &(argp->file), sizeof( NestFilehandle ) );
    nest_debug( NEST_DEBUG_NFS, "nfs setattr req for %s received\n",
        nestStorageManager::filehandleToPath( &nest_fh ) ); 

    nestRequest *req = new nestRequest( SETATTR_REQUEST, NULL, 0, 0, 0, 0, 0 ); 
    req->setFilehandle( &(argp->file) );
    req->setFileattr( argp );
    
    return req;
}

nestRequest *
nfsproc_root_2_svc(void *argp, struct svc_req *rqstp)
{
    nest_debug( NEST_DEBUG_NFS, "nfs root request received\n" );

    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
nfsproc_lookup_2_svc(diropargs *argp, struct svc_req *rqstp)
{

    nestRequest    *req;

    nest_debug( NEST_DEBUG_NFS, "nfs lookup %d:%s request received\n", 
            nfsFilehandleToInt( &argp->dir ), argp->name );

    req = new nestRequest( GET_FILEHANDLE, 
            (char*)argp->name, 0, 0, 0, 0, 0 );
    req->setFilehandle( (void *)&argp->dir );

    return req;
}

nestRequest *
nfsproc_readlink_2_svc(nfs_fh *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
nfsproc_read_2_svc(readargs *argp, struct svc_req *rqstp)
{
    nest_debug( NEST_DEBUG_NFS, 
    //nest_printf(
            "nfs read %d request received\n", 
            nfsFilehandleToInt( &argp->file ) );

        // I think the whole end thing in nest_request sucks.
        // it should be a length not another offset . . .
    nestRequest *req =  new nestRequest( CLIENT_RECV_FILE, NULL, 0, 0, 
            argp->offset, argp->offset + argp->count, 0 );
    // argp->totalcount is unused
    req->setFilehandle( &argp->file );
    return req; 
}

nestRequest *
nfsproc_writecache_2_svc(void *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
nfsproc_write_2_svc(writeargs *argp, struct svc_req *rqstp)
{
    nest_debug( NEST_DEBUG_NFS,
            "nfs write %d request received\n",
            nfsFilehandleToInt( &argp->file ) ); 
    nestRequest *req =  new nestRequest( CLIENT_SEND_FILE, NULL, 0, 0,
            argp->offset, argp->offset + argp->data.data_len, 0 );
    req->setFilehandle( &argp->file );
    return req;
}

nestRequest *
nfsproc_create_2_svc(createargs *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
nfsproc_remove_2_svc(diropargs *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
nfsproc_rename_2_svc(renameargs *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
nfsproc_link_2_svc(linkargs *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
nfsproc_symlink_2_svc(symlinkargs *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
nfsproc_mkdir_2_svc(createargs *argp, struct svc_req *rqstp)
{
    filename file = argp->where.name;
    nest_debug( NEST_DEBUG_NFS, "nfs mkdir %s request received\n", file );

    nestRequest *req = new nestRequest( MKDIR_REQUEST, file, 0, 0, 0, 0 );
    req->setFilehandle( &argp->where.dir );
    return req;
}

nestRequest *
nfsproc_rmdir_2_svc(diropargs *argp, struct svc_req *rqstp)
{
        
    filename file = argp->name;
    nest_debug( NEST_DEBUG_NFS, "nfs rmdir %s request received\n", file );

    nestRequest *req = new nestRequest( RMDIR_REQUEST, file, 0, 0, 0, 0 );
    req->setFilehandle( &argp->dir );
    return req;
}

nestRequest *
nfsproc_readdir_2_svc(readdirargs *argp, struct svc_req *rqstp)
{
    nest_debug( NEST_DEBUG_NFS, "nfs readdir req recvd.\n" );
    nestRequest *req = new nestRequest( DIR_LIST_REQUEST, 0, 0, 0, 0, 0 );
    req->setFilehandle( &argp->dir );
    return req;
}

nestRequest *
nfsproc_statfs_2_svc(nfs_fh *argp, struct svc_req *rqstp)
{
    nest_debug( NEST_DEBUG_NFS, "Statfs req recvd. handling as avail space\n" );
    return new nestRequest( AVAILABLE_SPACE_QUERY, 0, 0, 0, 0, 0 );
}

nestRequest *
mountproc_null_1_svc(void *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
mountproc_mnt_1_svc(dirpath *argp, struct svc_req *rqstp)
{

    nest_debug( NEST_DEBUG_NFS, "Mount request to mount %s\n", *argp );
    // TODO  we probably need a distinct mount command.
    //       two reasons:  One) mounts are stateful 
    //                     Two) mounts should fail if path is not dir

    nestRequest *req = new nestRequest( GET_FILEHANDLE, 
            (char*)*argp, 0, 0, 0, 0, 0 );
            
    return req;
}

nestRequest *
mountproc_dump_1_svc(void *argp, struct svc_req *rqstp)
{

    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
mountproc_umnt_1_svc(dirpath *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
mountproc_umntall_1_svc(void *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
mountproc_export_1_svc(void *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}

nestRequest *
mountproc_exportall_1_svc(void *argp, struct svc_req *rqstp)
{
    NFS_WARN;
    return new nestRequest( BAD_REQUEST, 0, 0, 0, NEST_NOT_YET_IMPLEMENTED, 0 );
}
