#ifndef __NEST_NFS_UTIL_H
#define __NEST_NFS_UTIL_H

#include <assert.h>
#include "nfs_prot.h"
#include "nfs_mount.h"
#include "nest_error.h"

#include "rpcudp_lib.h"

char *nfs_error(   enum nfsstat nfssstat );
char *nfs_request( int req );
char *mount_request( int req );
void nfs_dump_request( struct svc_req *rqstp, char *req, bool suppress_ip = true );

int   nfsFilehandleToInt( void *nfs_fh );
int   filehandleToInt(    NestFilehandle *handle );
void *filehandleCopy(     void *nfs_fh, NestFilehandle *handle );
void *filehandleCopy2(    NestFilehandle *handle, void *nfs_fh );

NestReplyStatus NFSStatusToNestStatus( enum nfsstat status );
enum nfsstat NestStatusToNFSStatus( NestReplyStatus status ); 

#endif
